`timescale 1ns/1ps
module tb_crc32();

localparam T=2.0;
localparam Td=T/2.0;

localparam DW = 8;

reg clk, rst, feed;
reg [DW-1:0] data_in;
wire [31:0] crc_o;

always@(*) #Td clk<=~clk;


// dut
wrap_crc32 #(.DWIDTH(DW))
dut(
    .clk(clk),
    .feed(feed),
    .syn_rst(rst),
    .data_in(data_in),
    .crc_o(crc_o)
);


initial begin
    clk = 0;
    feed = 0;
    rst = 1;

    #0.01;

    #(2*T);
    rst = 0;
    #T;
    
    data_in = 8'h00;
    feed = 1;
    #T;

    data_in = 8'h01;
    feed = 1;
    #T;

    data_in = 8'hfe;
    feed = 1;
    #T;

    feed = 0;
    #T;
    #T;

    $finish;

end

endmodule
