module wrap_crc32
#
(
    parameter DWIDTH = 8
)
(
    input clk,
    input feed,
    input syn_rst,
    input [DWIDTH-1:0] data_in,
    output [31:0] crc_o
);

wire [31:0] crc_out_tmp;

ucrc_par
#
(
    .POLYNOMIAL(
        {
            1'b0, // 31 
            1'b0, // 30
            1'b0, // 29
            1'b0, // 28
            1'b0, // 27
            1'b1, // 26
            1'b0, // 25
            1'b0, // 24
            1'b1, // 23
            1'b1, // 22
            1'b0, // 21
            1'b0, // 20
            1'b0, // 19
            1'b0, // 18
            1'b0, // 17
            1'b1, // 16
            1'b0, // 15
            1'b0, // 14
            1'b0, // 13
            1'b1, // 12
            1'b1, // 11
            1'b1, // 10
            1'b0, // 9
            1'b1, // 8
            1'b1, // 7
            1'b0, // 6
            1'b1, // 5
            1'b1, // 4
            1'b0, // 3
            1'b1, // 2
            1'b1, // 1
            1'b1  // 0
        }
    ),
    .INIT_VALUE(
        {
            1'b1,
            1'b1,
            1'b1,
            1'b1,
            1'b1,
            1'b1,
            1'b1,
            1'b1,
            1'b1,
            1'b1,
            1'b1,
            1'b1,
            1'b1,
            1'b1,
            1'b1,
            1'b1,
            1'b1,
            1'b1,
            1'b1,
            1'b1,
            1'b1,
            1'b1,
            1'b1,
            1'b1,
            1'b1,
            1'b1,
            1'b1,
            1'b1,
            1'b1,
            1'b1,
            1'b1,
            1'b1
        }
    ),
    .DATA_WIDTH(8),
    .SYNC_RESET(1)
)
crc_unit(
    .clk_i(clk),
    .rst_i(syn_rst),
    .clken_i(feed),
    .data_i(data_in),
    .crc_o(crc_out_tmp)
);

wire [31:0] rev_crc_o = ~crc_out_tmp;

genvar i;
generate
for(i=0;i<32;i=i+1) begin: rev_b
    assign crc_o[31-i] = rev_crc_o[i];
end
endgenerate


endmodule
