module AES_SBOX(data_in, data_out);//, clk); 

input 	[7:0] data_in;
//reg [7:0] in;
//input  clk;
output	[7:0] data_out;

wire	[7:0] inTrans;
wire	[3:0] out5, out4, out3, out2, out1, out0;
                  
// instantiation
eightBitLambdaTrans				lambdaTrans(.in(data_in),.out(inTrans));

fourBitSquarer					square(.in(inTrans[7:4]),.out(out5));
fourBitLambdaMult				lambda(.in(out5),.out(out4));

fourBitMultiplier				mult2(.in1(inTrans[7:4] ^ inTrans[3:0]),.in0(inTrans[3:0]),.out(out3));

fourBitInverter					inv(.in(out4 ^ out3),.out(out2));

fourBitMultiplier				mult1(.in1(inTrans[7:4]),.in0(out2),.out(out1));
fourBitMultiplier				mult0(.in1(inTrans[7:4] ^ inTrans[3:0]),.in0(out2),.out(out0));

eightBitInvLambdaAffineTrans	invLambdaAffineTrans(.in({out1,out0}),.out(data_out));

endmodule