----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    16:32:07 01/12/2018 
-- Design Name: 
-- Module Name:    AES_SBOX_LAYER - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity AES_SBOX_LAYER is
	 generic (
			  P_algo : integer := 1);
    Port ( data_in : in  STD_LOGIC_VECTOR (P_algo*8-1 downto 0);
           data_in_MUT : in  STD_LOGIC_VECTOR (7 downto 0);
           data_out : out  STD_LOGIC_VECTOR (P_algo*8-1 downto 0);
           data_out_MUT : out  STD_LOGIC_VECTOR (7 downto 0));
end AES_SBOX_LAYER;

architecture Behavioral of AES_SBOX_LAYER is

-- AES SBOX
component AES_SBOX is
    Port ( data_in : in  STD_LOGIC_VECTOR (7 downto 0);
           data_out : out  STD_LOGIC_VECTOR (7 downto 0));
end component AES_SBOX;

attribute keep_hierarchy : string;
attribute keep_hierarchy of Behavioral : architecture is "yes";

begin

SBOX_MUT : AES_SBOX
	port map (
			data_in => data_in_MUT,
			data_out => data_out_MUT
			);

SBOX_P_ALGO :
	for N in 0 to (P_algo - 1) generate
		S_X : AES_SBOX
			port map (
				data_in => data_in(N*8+7 downto N*8),
				data_out => data_out(N*8+7 downto N*8)
				);
			end generate;

end Behavioral;

