----------------------------------------------------------------------------------
-- Company: UCL Crypto Group
-- Engineer: Davide Bellizia
-- 
-- Create Date:    21:12:46 01/18/2018 
-- Design Name: 
-- Module Name:    MixColumns_4byte - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity MixColumns_4byte is
    Port ( data_in : in  STD_LOGIC_VECTOR (31 downto 0);
           data_out : out  STD_LOGIC_VECTOR (31 downto 0)
			  );
end MixColumns_4byte;

architecture Behavioral of MixColumns_4byte is

signal data_0, data_1, data_2, data_3 : std_logic_vector (7 downto 0);
signal data_2_0, data_2_1, data_2_2, data_2_3 : std_logic_vector (7 downto 0);
signal data_3_0, data_3_1, data_3_2, data_3_3 : std_logic_vector (7 downto 0);


begin

data_0 <= data_in (31 downto 24);
data_1 <= data_in (23 downto 16);
data_2 <= data_in (15 downto 8);
data_3 <= data_in (7 downto 0);

-- mult GF(2^8) x2
data_2_0 <= data_0 (6 downto 4) & (data_0(7) xor data_0(3)) & (data_0(7) xor data_0(2)) & data_0(1) & (data_0(7) xor data_0(0)) & data_0(7);
data_2_1 <= data_1 (6 downto 4) & (data_1(7) xor data_1(3)) & (data_1(7) xor data_1(2)) & data_1(1) & (data_1(7) xor data_1(0)) & data_1(7);
data_2_2 <= data_2 (6 downto 4) & (data_2(7) xor data_2(3)) & (data_2(7) xor data_2(2)) & data_2(1) & (data_2(7) xor data_2(0)) & data_2(7);
data_2_3 <= data_3 (6 downto 4) & (data_3(7) xor data_3(3)) & (data_3(7) xor data_3(2)) & data_3(1) & (data_3(7) xor data_3(0)) & data_3(7);

-- mult GF(2^8) x3
data_3_0 <= data_2_0 xor data_0;
data_3_1 <= data_2_1 xor data_1;
data_3_2 <= data_2_2 xor data_2;
data_3_3 <= data_2_3 xor data_3;

-- final mix
data_out (31 downto 24) <= data_2_0 xor data_3_1 xor data_2 xor data_3;
data_out (23 downto 16) <= data_0 xor data_2_1 xor data_3_2 xor data_3;
data_out (15 downto 8)  <= data_0 xor data_1 xor data_2_2 xor data_3_3;
data_out (7 downto 0)	<= data_3_0 xor data_1 xor data_2 xor data_2_3;

end Behavioral;

