----------------------------------------------------------------------------------
-- Company: UCL Crypto Group
-- Engineer: Davide Bellizia
-- 
-- Create Date:    11:47:29 01/19/2018 
-- Design Name: 
-- Module Name:    ShiftRows_4byte - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity ShiftRows_4byte is
    Port ( data_in : in  STD_LOGIC_VECTOR (31 downto 0);
           data_out : out  STD_LOGIC_VECTOR (31 downto 0);
           inn_s : in  STD_LOGIC_VECTOR (2 downto 0));
end ShiftRows_4byte;

architecture Behavioral of ShiftRows_4byte is

begin

data_0 <= data_in (31 downto 24);
data_1 <= data_in (23 downto 16);
data_2 <= data_in (15 downto 8);
data_3 <= data_in (7 downto 0);

SR_insn :
	process (inn_s,data_in)
	begin
		case inn_s is
			when "00" =>
				data_out <= data_in;
			when "01" =>
				data_out <= data_1 & data_2 & data_3 & data_0;
			when "10" =>
				data_out <= data_2 & data_3 & data_0 & data_1;
			when "11" =>
				data_out <= data_3 & data_0 & data_1 & data_2;
			when others =>
				data_out <= (others => '0');
		end case;
	end process;
end Behavioral;

