module fourBitMultiplier(in1, in0, out);

input 	[3:0] in1;
input 	[3:0] in0;
output	[3:0] out;

wire	[1:0] out2, out1, out0, out2phi;

// instansiation
twoBitMultiplier 	mult2bit2(.in1(in1[3:2]),.in0(in0[3:2]),.out(out2));
twoBitMultiplier 	mult2bit1(.in1(in1[3:2] ^ in1[1:0]),.in0(in0[3:2] ^ in0[1:0]),.out(out1));
twoBitMultiplier 	mult2bit0(.in1(in1[1:0]),.in0(in0[1:0]),.out(out0));  
twoBitPhiMult 		phi2bit(.in(out2),.out(out2phi));                  

// the code
assign 	out[3:2] = out1 ^ out0;
assign 	out[1:0] = out2phi ^ out0;

endmodule 