// SPDX-FileCopyrightText: SIMPLE-Crypto Contributors <info@simple-crypto.dev>
// SPDX-License-Identifier: CERN-OHL-P-2.0
// Copyright SIMPLE-Crypto Contributors.
// This source describes Open Hardware and is licensed under the CERN-OHL-P v2.
// You may redistribute and modify this source and make products using it under
// the terms of the CERN-OHL-P v2 (https://ohwr.org/cern_ohl_p_v2.txt).
// This source is distributed WITHOUT ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING
// OF MERCHANTABILITY, SATISFACTORY QUALITY AND FITNESS FOR A PARTICULAR PURPOSE.
// Please see the CERN-OHL-P v2 for applicable conditions.

module pipe_reg 
#(
    parameter W = 3,
    parameter DEPTH = 2
)
(
    input clk,
    input [W-1:0] in,
    output [W-1:0] out
);


genvar i;
generate
for(i=0;i<DEPTH;i=i+1) begin: stage
    wire [W-1:0] stin;
    reg [W-1:0] stout;

    always@(posedge clk)
    begin
        stout <= stin;
    end

    if(i==0) begin
        assign stin = in;
    end else begin
        assign stin = stage[i-1].stout;
    end
end
endgenerate

assign out = stage[DEPTH-1].stout;


endmodule
