// SPDX-FileCopyrightText: SIMPLE-Crypto Contributors <info@simple-crypto.dev>
// SPDX-License-Identifier: CERN-OHL-S-2.0
// Copyright SIMPLE-Crypto Contributors.
// This source describes Open Hardware and is licensed under the CERN-OHL-S v2.
// You may redistribute and modify this source and make products using it under
// the terms of the CERN-OHL-S v2 (https://ohwr.org/cern_ohl_s_v2.txt ).
// This source is distributed WITHOUT ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING
// OF MERCHANTABILITY, SATISFACTORY QUALITY AND FITNESS FOR A PARTICULAR PURPOSE.
// Please see the CERN-OHL-S v2 for applicable conditions.
// Source location: https://github.com/simple-crypto/SMAesH
// As per CERN-OHL-S v2 section 4, should You produce hardware based
// on this source, You must where practicable maintain the Source Location
// visible on the external case of any product you make using this source.

`timescale 1ns / 1ps
module MSK_tgf_out #(parameter d = 2) (
    // CLK
    clk,
    // FLAGS
    sel,            // Sel input
    // PAYLOADS
    key,
    state_in,
    m_tag
);
input clk;
input sel;
input [0:128*d-1] key;
input [0:320*d-1] state_in;
output [0:128*d-1] m_tag;

// REGS & WIRE
reg sel_F;
wire [0:128*d-1] mux_key, m_0;

always @(posedge clk ) sel_F <= sel;

MSKcst #(.d(d), .count(128)) cst_0 (128'b0, m_0);

MSKmux #(.d(d), .count(128)) mux_k_tgf (sel_F, key, m_0, mux_key);
MSKxor #(.d(d), .count(128)) tgf_xor (mux_key, state_in[192*d:320*d-1], m_tag);

endmodule