// SPDX-FileCopyrightText: SIMPLE-Crypto Contributors <info@simple-crypto.dev>
// SPDX-License-Identifier: CERN-OHL-S-2.0
// Copyright SIMPLE-Crypto Contributors.
// This source describes Open Hardware and is licensed under the CERN-OHL-S v2.
// You may redistribute and modify this source and make products using it under
// the terms of the CERN-OHL-S v2 (https://ohwr.org/cern_ohl_s_v2.txt ).
// This source is distributed WITHOUT ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING
// OF MERCHANTABILITY, SATISFACTORY QUALITY AND FITNESS FOR A PARTICULAR PURPOSE.
// Please see the CERN-OHL-S v2 for applicable conditions.
// Source location: https://github.com/simple-crypto/SMAesH
// As per CERN-OHL-S v2 section 4, should You produce hardware based
// on this source, You must where practicable maintain the Source Location
// visible on the external case of any product you make using this source.

`timescale 1ns / 1ps
module MSK_PermC #(parameter d = 2) (
    state,
    roundcst,
    update
);
    parameter W = 64;

    input [5*W*d-1 : 0] state;
    input [8*d-1 : 0] roundcst;
    output [5*W*d-1 : 0] update;

    MSKxor #(.d(d), .count(8)) xor1 (state[136*d-1 : 128*d], roundcst, update[136*d-1 : 128*d]);

    assign update[5*W*d-1 : 136*d] = state[5*W*d-1 : 136*d];
    assign update[2*W*d-1 : 0] = state[2*W*d-1 : 0];

endmodule