// SPDX-FileCopyrightText: SIMPLE-Crypto Contributors <info@simple-crypto.dev>
// SPDX-License-Identifier: CERN-OHL-S-2.0
// Copyright SIMPLE-Crypto Contributors.
// This source describes Open Hardware and is licensed under the CERN-OHL-S v2.
// You may redistribute and modify this source and make products using it under
// the terms of the CERN-OHL-S v2 (https://ohwr.org/cern_ohl_s_v2.txt ).
// This source is distributed WITHOUT ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING
// OF MERCHANTABILITY, SATISFACTORY QUALITY AND FITNESS FOR A PARTICULAR PURPOSE.
// Please see the CERN-OHL-S v2 for applicable conditions.
// Source location: https://github.com/simple-crypto/SMAesH
// As per CERN-OHL-S v2 section 4, should You produce hardware based
// on this source, You must where practicable maintain the Source Location
// visible on the external case of any product you make using this source.

`timescale 1ns/1ps
module CstGen_spa (
clk, 
sel, 
init,
rounding);

input clk, sel, en;
input [0:8] init;
output reg [7:0] rounding;

wire [7:0] rounded, outmux1, outmux;

assign outmux1 = (sel) ? init : rounded;
assign outmux = (en) ? outmux1 : rounding;

always @(posedge clk) begin
    rounding <= outmux;
end

assign rounded[4 +: 4] = rounding[4 +: 4] - 4'b0011;
assign rounded[0 +: 4] = rounding[0 +: 4] + 4'b0011;

endmodule