// SPDX-FileCopyrightText: SIMPLE-Crypto Contributors <info@simple-crypto.dev>
// SPDX-License-Identifier: CERN-OHL-S-2.0
// Copyright SIMPLE-Crypto Contributors.
// This source describes Open Hardware and is licensed under the CERN-OHL-S v2.
// You may redistribute and modify this source and make products using it under
// the terms of the CERN-OHL-S v2 (https://ohwr.org/cern_ohl_s_v2.txt ).
// This source is distributed WITHOUT ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING
// OF MERCHANTABILITY, SATISFACTORY QUALITY AND FITNESS FOR A PARTICULAR PURPOSE.
// Please see the CERN-OHL-S v2 for applicable conditions.
// Source location: https://github.com/simple-crypto/SMAesH
// As per CERN-OHL-S v2 section 4, should You produce hardware based
// on this source, You must where practicable maintain the Source Location
// visible on the external case of any product you make using this source.

`timescale 1ns / 1ps
module SPA_rc_gen (
clk, 
sel, 
init,
outmux
);

input clk, sel;
input [0:7] init;
output [7:0] outmux;

wire [7:0] rounding, init_spa, init_dpa, outmux;
reg [7:0] rounded;

assign outmux = (sel) ? init : rounded;

assign rounding[4 +: 4] = outmux[4 +: 4] - 4'b0011;
assign rounding[0 +: 4] = outmux[0 +: 4] + 4'b0011;

always @(posedge clk) begin
    rounded <= rounding;
end

endmodule