// SPDX-FileCopyrightText: SIMPLE-Crypto Contributors <info@simple-crypto.dev>
// SPDX-License-Identifier: CERN-OHL-S-2.0
// Copyright SIMPLE-Crypto Contributors.
// This source describes Open Hardware and is licensed under the CERN-OHL-S v2.
// You may redistribute and modify this source and make products using it under
// the terms of the CERN-OHL-S v2 (https://ohwr.org/cern_ohl_s_v2.txt ).
// This source is distributed WITHOUT ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING
// OF MERCHANTABILITY, SATISFACTORY QUALITY AND FITNESS FOR A PARTICULAR PURPOSE.
// Please see the CERN-OHL-S v2 for applicable conditions.
// Source location: https://github.com/simple-crypto/SMAesH
// As per CERN-OHL-S v2 section 4, should You produce hardware based
// on this source, You must where practicable maintain the Source Location
// visible on the external case of any product you make using this source.

`timescale 1ns/1ps
module Sbox (clk, in, out);
// INPUT / OUTPUT
input clk;
input [0 : 5-1] in;
output [0 : 5-1] out;

// INTERMEDIATE VALUES

wire x_xor1_0, x_xor2_0, x_xor1_1, x_xor1_2, x_xor2_2, x_xor1_3, x_xor1_4;
wire x_out_0, x_out_1, x_out_2, x_out_3, x_out_4;

// PROCESSING

assign x_xor1_0 = in[4] ^ in[0];
assign x_out_0 = (1 ^ x_xor1_0) & in[1];
assign x_xor2_0 = x_xor1_0 ^ x_out_1;
assign out[0] = x_xor2_0 ^ out[4];

assign x_xor1_1 = in[1] ^ x_out_2;
assign x_out_1 = (1 ^ in[1]) & x_xor1_2;
assign out[1] = x_xor1_1 ^ x_xor2_0;

assign x_xor1_2 = in[1] ^ in[2];
assign x_out_2 = (1 ^ x_xor1_2) & in[3];
assign x_xor2_2 = x_xor1_2 ^ x_out_3;
assign out[2] = 1 ^ x_xor2_2;

assign x_xor1_3 = in[3] ^ x_out_4;
assign x_out_3 = (1 ^ in[3]) & x_xor1_4;
assign out[3] = x_xor1_3 ^ x_xor2_2;

assign x_xor1_4 = in[3] ^ in[4];
assign out[4] = x_out_0 ^ x_xor1_4;
assign x_out_4 = (1 ^ x_xor1_4) & x_xor1_0;
endmodule