// SPDX-FileCopyrightText: SIMPLE-Crypto Contributors <info@simple-crypto.dev>
// SPDX-License-Identifier: CERN-OHL-S-2.0
// Copyright SIMPLE-Crypto Contributors.
// This source describes Open Hardware and is licensed under the CERN-OHL-S v2.
// You may redistribute and modify this source and make products using it under
// the terms of the CERN-OHL-S v2 (https://ohwr.org/cern_ohl_s_v2.txt ).
// This source is distributed WITHOUT ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING
// OF MERCHANTABILITY, SATISFACTORY QUALITY AND FITNESS FOR A PARTICULAR PURPOSE.
// Please see the CERN-OHL-S v2 for applicable conditions.
// Source location: https://github.com/simple-crypto/SMAesH
// As per CERN-OHL-S v2 section 4, should You produce hardware based
// on this source, You must where practicable maintain the Source Location
// visible on the external case of any product you make using this source.

`timescale 1ns / 1ps
module SPA_tb_ascon_spa ();

reg [319:0] in;
wire [319:0] out;
reg clk;

reg reset, start_dut, last;
wire done, transition;
localparam Tclk = 10;
localparam Tclkd = (Tclk/2.0);
always @(*) #(Tclk/2.0) clk <= ~clk;

SPA_Ascon_FSM #(d) dut (start_dut, clk, reset, last, in, done, transition, out);

initial begin
	$dumpfile (`VCD_FILE);
    $dumpvars (0, SPA_tb_ascon_spa);
    clk = 0;
    reset = 1;
    #40
    reset = 0;
    start_dut = 1;
    in = {64'h80400c0600000000, {(256){1'b0}}};
    last = 1;
    #10 
    start_dut = 0;
    in = 320'hX;
end

always@(done) begin
	if(done) begin
		#20
		$finish();
	end
end
endmodule
