`timescale 1ns / 1ps
module MSK_PermL #(parameter d = 2, width = 64) (state, update); 

    (* syn_keep = "true", keep = "true", fv_type = "sharing", fv_latency = 0, fv_count = 320 *) input [5*width*d-1 : 0] state;
    (* syn_keep = "true", keep = "true", fv_type = "sharing", fv_latency = 0, fv_count = 320 *) output [5*width*d-1 : 0] update;

    wire [width*d-1 : 0] x0, x1, x2, x3, x4;
    wire [width*d-1 : 0] x0_p1, x0_p2, x1_p1, x1_p2, x2_p1, x2_p2, x3_p1, x3_p2, x4_p1, x4_p2;
    wire [width*d-1 : 0] x0_modif, x1_modif, x2_modif, x3_modif, x4_modif;

    assign x0 = state[5*width*d-1 : 4*width*d];
    assign x1 = state[4*width*d-1 : 3*width*d];
    assign x2 = state[3*width*d-1 : 2*width*d];
    assign x3 = state[2*width*d-1 : width*d];
    assign x4 = state[width*d-1 : 0];

    //L1
    assign x0_p1 = {x0[(19%width)*d-1 : 0], x0[width*d-1 : (19%width)*d]};
    assign x0_p2 = {x0[(28%width)*d-1 : 0], x0[width*d-1 : (28%width)*d]};
    MSKxor #(.d(d), .count(width)) xor1 (x0_p1, x0_p2, x0_modif);
    MSKxor #(.d(d), .count(width)) xor2 (x0, x0_modif, update[5*width*d-1 : 4*width*d]);
    //L2
    assign x1_p1 = {x1[(61%width)*d-1 : 0], x1[width*d-1 : (61%width)*d]};
    assign x1_p2 = {x1[(39%width)*d-1 : 0], x1[width*d-1 : (39%width)*d]};
    MSKxor #(.d(d), .count(width)) xor3 (x1_p1, x1_p2, x1_modif);
    MSKxor #(.d(d), .count(width)) xor4 (x1, x1_modif, update[4*width*d-1 : 3*width*d]);
    //L3
    assign x2_p1 = {x2[d-1 : 0], x2[width*d-1 : d]};
    assign x2_p2 = {x2[(6%width)*d-1 : 0], x2[width*d-1 : (6%width)*d]};
    MSKxor #(.d(d), .count(width)) xor5 (x2_p1, x2_p2, x2_modif);
    MSKxor #(.d(d), .count(width)) xor6 (x2, x2_modif, update[3*width*d-1 : 2*width*d]);
    //L4
    assign x3_p1 = {x3[(10%width)*d-1 : 0], x3[width*d-1 : (10%width)*d]};
    assign x3_p2 = {x3[(17%width)*d-1 : 0], x3[width*d-1 : (17%width)*d]};
    MSKxor #(.d(d), .count(width)) xor7 (x3_p1, x3_p2, x3_modif);
    MSKxor #(.d(d), .count(width)) xor8 (x3, x3_modif, update[2*width*d-1 : width*d]);
    //L5
    assign x4_p1 = {x4[(7%width)*d-1 : 0], x4[width*d-1 : (7%width)*d]};
    assign x4_p2 = {x4[(41%width)*d-1 : 0], x4[width*d-1 : (41%width)*d]};
    MSKxor #(.d(d), .count(width)) xor9 (x4_p1, x4_p2, x4_modif);
    MSKxor #(.d(d), .count(width)) xor10 (x4, x4_modif, update[width*d-1 : 0]);

endmodule