`timescale 1ns / 1ps
module dpa_rc_gen (
clk, 
sel, 
sel_dpa,
outmux);

input clk, sel, sel_dpa;
output [7:0] outmux;

wire [7:0] rounding, init, init_spa, init_dpa, outmux;
reg [7:0] rounded;

assign init_dpa = 8'hF0;
assign init_spa = 8'h96;

assign init = (sel_dpa) ? init_dpa : init_spa;
assign outmux = (sel) ? init : rounded;

assign rounding[4 +: 4] = outmux[4 +: 4] - 4'b0001;
assign rounding[0 +: 4] = outmux[0 +: 4] + 4'b0001;

always @(posedge clk) begin
    rounded <= rounding;
end

endmodule