`timescale 1ns / 1ps
module HPC3plus_tb ();

parameter d = 2;
parameter rand_hpc3 = d*(d-1);

wire [d-1:0] out;

reg [d-1:0] ina, inb;
reg [rand_hpc3-1:0] rnd;
reg clk, gating;

// Clock generation
localparam Tclk = 10;
localparam Tclkd = (Tclk/2.0);
always @(*) #(Tclk/2.0) clk <= ~clk;

//MSKand_HPC4 #(d) dut (ina, inb, rnd, gating, clk, out);
MSKand_HPC3 dut_ref (ina, inb, rnd, clk, out);

initial begin
    $dumpfile("waveform.vcd");
    $dumpvars(0, HPC3plus_tb);
    clk = 0; 
    rnd = 4'b1111;
    //rnd = 15'b101010101010101;
    #10
    ina = {(d){1'b0}};
    gating = 0;
    inb = {(d){1'b0}};
    #10
    ina = {(d-1){1'b1}}|{1'b0};
    inb = {(d){1'b0}};
    gating = 0;
    #10
    ina = {(d-1){1'b1}}|{1'b0};
    inb = {(d-1){1'b1}}|{1'b0};
    #10
    ina = {(d-1){1'b0}}|{2'b01};
    inb = {(d-1){1'b0}}|{2'b10};
    #10
    ina = {(d-1){1'b0}}|{1'b1};
    inb = {(d-1){1'b0}}|{1'b1};
    //rnd = {(rand_hpc4){1'b0}};
    #100
    $finish();
end

endmodule
