module top_prolead_ascon_hpc4 #(parameter width = 1) (
    input wire clk,
    input wire start,
    input wire reset,
    input wire [width*3-1:0] state_in0,
    input wire [width*3-1:0] state_in1,
    input wire [width*2-1:0] key_in0,
    input wire [width*2-1:0] key_in1,
    input wire [25*width-1:0] rnd,
    output wire [width*5*2-1:0] state_out,
    output wire done
);

wire [width*3*2-1:0] state_in;
wire [width*2*2-1:0] key_in;

genvar i;

for (i=0; i<width*3; i=i+1) begin: state_in_wrap
    assign state_in[2*i] = state_in0[i];
    assign state_in[2*i+1] = state_in1[i];
end

for (i=0; i<width*2; i=i+1) begin: key_in_wrap
    assign key_in[2*i] = key_in0[i];
    assign key_in[2*i+1] = key_in1[i];
end

DPA_Ascon_FSM #(.d(2), .width(width)) inner (
    .clk(clk),
    .start(start),
    .flag_dp_perm_a(1'b0),
    .reset(reset),
    .last(1'b0),
    .state_in(state_in),
    .key_in(key_in),
    .rnd(rnd),
    .state_out(state_out),
    .done(done)
);

endmodule
