// SPDX-FileCopyrightText: SIMPLE-Crypto Contributors <info@simple-crypto.dev>
// SPDX-License-Identifier: CERN-OHL-P-2.0
// Copyright SIMPLE-Crypto Contributors.
// This source describes Open Hardware and is licensed under the CERN-OHL-P v2.
// You may redistribute and modify this source and make products using it under
// the terms of the CERN-OHL-P v2 (https://ohwr.org/cern_ohl_p_v2.txt).
// This source is distributed WITHOUT ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING
// OF MERCHANTABILITY, SATISFACTORY QUALITY AND FITNESS FOR A PARTICULAR PURPOSE.
// Please see the CERN-OHL-P v2 for applicable conditions.

`timescale 1ns / 1ps
module HPC2_tb ();

parameter d = 2;
parameter rand_hpc4 = 5*d*(d-1)/2;

wire [d-1:0] out;

reg [d-1:0] ina, inb;
reg [rand_hpc4-1:0] rnd;
reg clk, gating;

// Clock generation
localparam Tclk = 10;
localparam Tclkd = (Tclk/2.0);
always @(*) #(Tclk/2.0) clk <= ~clk;

//MSKand_HPC4 #(d) dut (ina, inb, rnd, gating, clk, out);
MSKand_HPC2 dut_ref (ina, inb, rnd, clk, out);

initial begin
    $dumpfile(`VCD_FILE);
    $dumpvars(0, HPC2_tb);
    clk = 0; 
    rnd = 5'h0E;
    //rnd = 15'b101010101010101;
    #10
    ina = {(d){1'b0}};
    gating = 0;
    inb = {(d){1'b0}};
    #10
    ina = {(d-1){1'b1}}|{1'b0};
    inb = {(d){1'b0}};
    gating = 0;
    #10
    ina = {(d-1){1'b1}}|{1'b0};
    inb = {(d-1){1'b1}}|{1'b0};
    #10
    ina = {(d-1){1'b0}}|{2'b01};
    inb = {(d-1){1'b0}}|{2'b10};
    #10
    ina = {(d-1){1'b0}}|{1'b1};
    inb = {(d-1){1'b0}}|{1'b1};
    //rnd = {(rand_hpc4){1'b0}};
    #100
    $finish();
end

endmodule
