// SPDX-FileCopyrightText: SIMPLE-Crypto Contributors <info@simple-crypto.dev>
// SPDX-License-Identifier: CERN-OHL-P-2.0
// Copyright SIMPLE-Crypto Contributors.
// This source describes Open Hardware and is licensed under the CERN-OHL-P v2.
// You may redistribute and modify this source and make products using it under
// the terms of the CERN-OHL-P v2 (https://ohwr.org/cern_ohl_p_v2.txt).
// This source is distributed WITHOUT ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING
// OF MERCHANTABILITY, SATISFACTORY QUALITY AND FITNESS FOR A PARTICULAR PURPOSE.
// Please see the CERN-OHL-P v2 for applicable conditions.

`timescale 1ns / 1ps
module HPC4_tb_gated ();

parameter d = 2;
parameter rand_hpc4 = 5*d*(d-1)/2;

wire [d-1:0] out;
wire [d-1:0] cs;
reg [0:d-1] ina, inb;
reg [rand_hpc4-1:0] rnd;
reg clk, gating, sel_frwd;

// Clock generation
localparam Tclk = 10;
localparam Tclkd = (Tclk/2.0);
always @(*) #(Tclk/2.0) clk <= ~clk;
MSKcst_gat #(.d(d), .count(1)) dumcst (1'b1, cs);
MSKand_HPC4_gated_d2 dut (ina, inb, rnd, sel_frwd, clk, out);
//MSKand_HPC2 #(d) dut_ref (ina, inb, rnd, clk, out);

initial begin
    $dumpfile(`VCD_FILE);
    $dumpvars(0, HPC4_tb_gated);
    clk = 0; 
    sel_frwd = 0;
    rnd = 5'h0E;
    //rnd = 15'b101010101010101;
    #10
    ina = {(d){1'b0}};
    inb = {(d){1'b0}};
    #10
    ina = 2'b10;
    inb = {(d){1'b0}};
    sel_frwd = 1;
    #10
    gating = 1;
    ina = 2'b10;
    inb = {(d-1){1'b1}}|{1'b0};
    #10
    ina = 2'b10;
    inb = {(d-1){1'b0}}|{2'b10};
    #10
    ina = {(d-1){1'b0}}|{1'b1};
    inb = {(d-1){1'b0}}|{1'b1};
    //rnd = {(rand_hpc4){1'b0}};
    #100
    $finish();
end

endmodule
