set_units -time 1ns

set PERIOD 10
set CLK_NAME clk

create_clock -name my_clock -period $PERIOD [get_ports $CLK_NAME] 

#set clock uncertainty (skew+jitter -> skew of 0.2ns and jitter of 0.1ns) and latency
set_clock_uncertainty -setup 0.3 $CLK_NAME
set_clock_uncertainty -hold 0.2 $CLK_NAME
set_clock_latency 1.0 $CLK_NAME

#set electrical environment around the design
set_drive 1.0 [remove_from_collection [all_inputs] $CLK_NAME]
set_load 1.0 [all_outputs]

#set input and output delays
set_input_delay 0.1 -clock my_clock [all_inputs]
set_output_delay 0.1 -clock my_clock [all_outputs]
