# Davide Bellizia - UCLouvain Crypto Group {davide.bellizia@uclouvain.be}
#setting units
set_units -time 1ns

set PERIOD 10
set CLK_NAME clk
#set RESET_NAME rst
set FANOUT 8
set DESIGN_NAME levelled_FSM

#set clock to 50ns of period
create_clock -name my_clock -period $PERIOD [get_ports $CLK_NAME] 

#set clock uncertainty (skew+jitter -> skew of 0.2ns and jitter of 0.1ns) and latency
set_clock_uncertainty -setup 0.3 $CLK_NAME
set_clock_uncertainty -hold 0.2 $CLK_NAME
set_clock_latency 1.0 $CLK_NAME
#set_clock_gating_check -setup 0.2 [get_cells CG_*]

#set electrical environment around the design
set_drive 1.0 [remove_from_collection [all_inputs] $CLK_NAME]
#set_drive 1.0 [remove_from_collection [all_inputs] $RESET_NAME]
set_load 1.0 [all_outputs]

#set input and output delays
set_input_delay 0.1 -clock my_clock [all_inputs]
set_output_delay 0.1 -clock my_clock [all_outputs]

#false paths
#set_false_path -from [get_ports $RESET_NAME]

#set maximum fanout 
#set_max_fanout $FANOUT $DESIGN_NAME
